(function($, $$, owner) {

	var confirm_Str = '确定';

	var cancel_Str = '取消';

	var open_Str = '打开';

	var networkProblem_Str = "网络故障，请重试";

	var updateNow_Str = '立即更新';

	var downloadWgtOrWgtu_Str = '更新包下载中...';

	var downloadWgtOrWgtuSuc_Str = '更新包下载成功';

	var downloadWgtOrWgtuFail_Str = '更新包下载失败';

	var installWgtOrWgtu_Str = '安装更新中...';

	var installWgtOrWgtuSuc_Str = '安装更新成功，即将重启应用';

	var installWgtOrWgtuSuc_android_Str = '安装更新成功，请重启应用';

	var installWgtOrWgtuFail_Str = '安装更新失败';

	var installWgtOrWgtuFail_notForce_Str = '安装更新包失败，可能会影响部分功能的使用，请稍后尝试重新更新';

	var installWgtOrWgtuFail_force_Str = '安装更新包失败，应用即将关闭，请手动删除应用并重新安装最新版本';

	var versionCheck_Str = '检测更新中...';

	var versionCheckFail_Str = "检测更新失败，请稍后重试";

	var newVersionAvailabe_Str = "发现新版本";

	var updateNecessary_Str = "该版本已停止维护，请下载最新版APP,获得更好的体验";

	var updateUnnecessary_Str = "检测到有新版本， 是否立即更新？";



	var ifClearStorage = false;



	//检测是否有新版本，以及新版本安装类型

	owner.updateCheck = function(userCommand) {

		if (userCommand) {

			plus.nativeUI.showWaiting(versionCheck_Str);

		}

		var appVer, versionCheck_ajax_url;

		if ($$.os.android) {

			versionCheck_ajax_url = versionCheck_ajax_url_android;

		} else {

			versionCheck_ajax_url = versionCheck_ajax_url_ios;

		}

		plus.runtime.getProperty(plus.runtime.appid, function(wgtinfo) {

			appVer = wgtinfo.version;

			if (debugFlag) $$.toast(appVer);

			owner.startCheck(appVer, versionCheck_ajax_url, userCommand);

		});

	};



	owner.startCheck = function(appVer, versionCheck_ajax_url, userCommand) {

		var dt = {

			"appid": plus.runtime.appid,

			"version": appVer,

			"from": versionCheck_from_market

		};
		$.ajax({

			url: commUrl + versionCheck_ajax_url,

			type: "POST",

			data: JSON.stringify({

				pageContext: {},

				data: JSON.stringify(dt)

			}),

			contentType: 'application/json;charset=utf-8',

			timeout: 15000,

			success: function(data) {

				if (userCommand) {

					plus.nativeUI.closeWaiting();

				}

				var btnArray = [updateNow_Str, cancel_Str];

				data = JSON.parse(data);

				if (data.status != 200) {

					if (userCommand) {

						$$.toast(versionCheckFail_Str);

					}

					return;

				}

				switch (data.code) {

					case "0":

						if (userCommand) {

							$$.toast(versionCheckFail_Str);

						}

						break;

					case "1":

						try {

							data = data.data;

							var dataArray = data.appstore.split(",");

							if (dataArray.length == 4) {

								ifClearStorage = dataArray[0] == "true" ? true : false;

								var upgradeMode = dataArray[1];

								var ifForce = dataArray[2];

								var upgradeUrl = dataArray[3];

								if (ifForce == "true") {

									$$.confirm(updateNecessary_Str, newVersionAvailabe_Str, btnArray, function(e) {

										if (e.index == 0) {

											switch (upgradeMode) {

												case "all":

													owner.packageUpdate(upgradeUrl, true);

													break;

												case "package":

													owner.wgtUpdate(upgradeUrl, true);

													break;

												case "file":

													owner.wgtuUpdate(upgradeUrl, true);

													break;

											}

										} else {

											plus.runtime.quit();

										}

									});

								} else if (ifForce == "false") {

									$$.confirm(updateUnnecessary_Str, newVersionAvailabe_Str, btnArray, function(e) {

										if (e.index == 0) {

											switch (upgradeMode) {

												case "all":

													owner.packageUpdate(upgradeUrl, false);

													break;

												case "package":

													owner.wgtUpdate(upgradeUrl, false);

													break;

												case "file":

													owner.wgtuUpdate(upgradeUrl, false);

													break;

											}

										} else {}

									});

								}

							} else {

								if (userCommand) {

									$$.toast(versionCheckFail_Str);

								}

							}

						} catch (err) {

							if (userCommand) {

								$$.toast(versionCheckFail_Str);

							}

						}

						break;

					case "2":

						if (userCommand) {

							$$.toast(appNewestVersion_Str);

						}

						break;

				}



			},

			error: function(xhr, type, errorThrown) {

				if (userCommand) {

					plus.nativeUI.closeWaiting();

					$$.toast(versionCheckFail_Str);

				}

			}

		});

	}



	/**

	 * 全包升级（基座升级）

	 **/

	owner.packageUpdate = function(pkgUrl) {

		if (debugFlag) $$.toast("packageUpdate  url:" + pkgUrl);

		var oldLocalStorgeLength = localStorage.length;

		if (ifClearStorage) localStorage.clear();

		//if (debugFlag) $$.alert("ifClearStorage = " + ifClearStorage + ",localStorageLength = " + localStorage.length + ",oldLocalStorageLength = " + oldLocalStorgeLength);

		plus.runtime.openURL(pkgUrl);

	};



	/**

	 * 资源文件整体升级

	 **/

	owner.wgtUpdate = function(wgtUrl, ifForce) {

		if (debugFlag) $$.toast("wgtUpdate  url:" + wgtUrl);

		plus.nativeUI.showWaiting(downloadWgtOrWgtu_Str);

		plus.downloader.createDownload(wgtUrl, {

			filename: "_doc/update/",

			timeout: 20,

			retry: 2,

			retryInterval: 1

		}, function(d, status) {

			plus.nativeUI.closeWaiting();

			if (status == 200) {

				var oldLocalStorgeLength = localStorage.length;

				if (ifClearStorage) localStorage.clear();

				//if (debugFlag) $$.alert("ifClearStorage = " + ifClearStorage + ",localStorageLength = " + localStorage.length + ",oldLocalStorageLength = " + oldLocalStorgeLength);

				if (debugFlag) $$.toast("installWgt  url:" + d.filename);

				owner.installWgt(d.filename, wgtUrl, ifForce);

			} else {

				$$.alert(downloadWgtOrWgtuFail_Str);

			}

		}).start();

	};



	/**

	 * 增量升级

	 **/

	owner.wgtuUpdate = function(wgtuUrl, ifForce) {

		if (debugFlag) $$.toast("wgtuUpdate  url:" + wgtuUrl);

		plus.nativeUI.showWaiting(downloadWgtOrWgtu_Str);

		plus.downloader.createDownload(wgtuUrl, {

			method: "GET",

			timeout: 20,

			retry: 2,

			retryInterval: 1

		}, function(d, status) {

			plus.nativeUI.closeWaiting();

			if (status == 200) {

				plus.nativeUI.showWaiting(installWgtOrWgtu_Str);

				plus.runtime.install(d.filename, {}, function() {

					if (plus.storage.getItem("wgtuRetried") != null) plus.storage.removeItem("wgtuRetried");

					var oldLocalStorgeLength = localStorage.length;

					if (ifClearStorage) localStorage.clear();

					//if (debugFlag) $$.alert("ifClearStorage = " + ifClearStorage + ",localStorageLength = " + localStorage.length + ",oldLocalStorageLength = " + oldLocalStorgeLength);

					plus.nativeUI.closeWaiting();

					if ($$.os.android) {

						plus.nativeUI.alert(installWgtOrWgtuSuc_android_Str, function() {

							plus.runtime.quit();

						});

					} else {

						plus.nativeUI.alert(installWgtOrWgtuSuc_Str, function() {

							plus.runtime.restart();

						});

					}

				}, function(error) {

					plus.nativeUI.closeWaiting();

					if (plus.storage.getItem("wgtuRetried") == null) {

						plus.storage.setItem("wgtuRetried", "true");

						owner.wgtuUpdate(wgtuUrl);

					} else {

						if (ifForce) $$.alert(installWgtOrWgtuFail_force_Str);

						else $$.alert(installWgtOrWgtuFail_notForce_Str);

						plus.storage.removeItem("wgtuRetried");

						if (debugFlag) $$.toast(installWgtOrWgtuFail_Str + error.message);

					}

				});

			} else {

				$$.alert(downloadWgtOrWgtuFail_Str);

			}

		}).start();

	};



	/**

	 * 安装升级包

	 **/

	owner.installWgt = function(path, wgtUrl, ifForce) {

		plus.nativeUI.showWaiting(installWgtOrWgtu_Str);

		plus.runtime.install(path, {

			force: true

		}, function() {

			if (plus.storage.getItem("wgtRetried") != null) plus.storage.removeItem("wgtRetried");

			plus.nativeUI.closeWaiting();

			if ($$.os.android) {

				plus.nativeUI.alert(installWgtOrWgtuSuc_android_Str, function() {

					plus.runtime.quit();

				});

			} else {

				plus.nativeUI.alert(installWgtOrWgtuSuc_Str, function() {

					plus.runtime.restart();

				});

			}

		}, function(error) {

			plus.nativeUI.closeWaiting();

			if (plus.storage.getItem("wgtRetried") == null) {

				plus.storage.setItem("wgtRetried", "true");

				owner.wgtUpdate(wgtUrl, ifForce);

			} else {

				if (ifForce) $$.alert(installWgtOrWgtuFail_force_Str);

				else $$.alert(installWgtOrWgtuFail_notForce_Str);

				plus.storage.removeItem("wgtRetried");

				if (debugFlag) $$.toast(installWgtOrWgtuFail_Str + error.message);

			}

		});

	};



	//	var wv = plus.webview.currentWebview();



	//	if(wv.id == "main.html") {



	//		owner.updateCheck();



	//	} else if(wv.id == "logout_setting.html"){



	//		var versionCheckHtml = '<li class="mui-table-view-cell"><a id="update" class="mui-navigate-right">检查更新</a></li>';



	//		$("#tel").parent().parent().append(versionCheckHtml);



	//		//检查更新



	//		document.getElementById("update").addEventListener('tap', function() {



	//			owner.updateCheck(1);



	//		});



	//	}

}(jQuery, mui, window.versionManagement = {}));

